//+------------------------------------------------------------------+
//|                                           Marc_Supertrend_EA.mq4 |
//|                                         Developed by Coders Guru |
//|                                   Copyrighted for Marc J Spindel |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+
#property copyright "Marc J Spindel"
#property link      "http://www.xpworx.com"
string   ver  = "Last Modified: 2011.11.17 19:0";
//+------------------------------------------------------------------+
extern   bool        CloseProfitableOnly     = false;
extern   int         period                  = 10;
extern   int         appliedPrice            = PRICE_CLOSE;
extern   double      multiplier              = 3.0;
//+------------------------------------------------------------------+
double   mPoint         = 0.0001;
//+------------------------------------------------------------------+
int init()
{
   mPoint = GetPoint(); 
   
   Comment(ver);
   
   return(0);
}
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}
//+------------------------------------------------------------------+
int start()
{   
   //-- GET SIGNSL --//
   double buf_0_c = iCustom(NULL,0,"SuperTrend",period,appliedPrice,multiplier,false,false,0,1);
   double buf_0_p = iCustom(NULL,0,"SuperTrend",period,appliedPrice,multiplier,false,false,0,2);
   
   int Exit = -1;  
   
    
   if(Close[1]>buf_0_c && Close[2]<buf_0_p) Exit = OP_SELL;
   if(Close[1]<buf_0_c && Close[2]>buf_0_p) Exit = OP_BUY;
   
   for(int cnt = 0; cnt < OrdersTotal(); cnt++)
   {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderType()==Exit && OrderSymbol()==Symbol() && (OrderProfit()>0.0 ||CloseProfitableOnly==false)) 
         CloseOrder(OrderTicket(),0,5,5,500); 
      }
   }
   
    return (0);
}
//+------------------------------------------------------------------+
double GetPoint()
{
   if(Digits==2 || Digits==3) return(0.01);
   if(Digits==4 || Digits==5) return(0.0001);
}
//+------------------------------------------------------------------+
double nd(double value)
{
   return(NormalizeDouble(value,Digits));
}
//+------------------------------------------------------------------+
bool CloseOrder(int ticket, double lots, int slippage, int tries, int pause)
{
   bool result=false;
   double ask = nd(Ask);
   double bid = nd(Bid);
   
   if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
   {
      if(OrderType()==OP_BUY)
      {
         for(int c = 0 ; c < tries ; c++)
         {
            if(lots==0) result = OrderClose(OrderTicket(),OrderLots(),bid,slippage,Violet);
            else result = OrderClose(OrderTicket(),lots,bid,slippage,Violet);
            if(result==true) break; 
            else
            {
               Sleep(pause);
               continue;
            }
         }
      }
      if(OrderType()==OP_SELL)
      {
         for(c = 0 ; c < tries ; c++)
         {
            if(lots==0) result = OrderClose(OrderTicket(),OrderLots(),ask,slippage,Violet);
            else result = OrderClose(OrderTicket(),lots,ask,slippage,Violet);
            if(result==true) break; 
            else
            {
               Sleep(pause);
               continue;
            }
         }
      }
   }
   return(result);
}

